//+------------------------------------------------------------------+
//|                                                       Setka.mq4  |
//|    17.02.2009                               .. |
//|                                             Skype -> privalov-sv |
//+------------------------------------------------------------------+
#property copyright " .."
#property link      "Skype -> privalov-sv"

#property indicator_chart_window

extern   double   =500.0;    //  
extern   int      London=0;     //  . 0 -  
extern   int      LimitBars=0;  //  . 0 -  

int PreBars;
datetime BarTime;
int StartPos, pos,i,Shet, PreVar;
bool  flag_G;

color LineColor;    //   
int   LineStile;    //   
int   Period_Ris;   //     
 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
//         
  ObjectsDeleteAll(0,OBJ_VLINE);
  ObjectsDeleteAll(0,OBJ_HLINE);
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator reset function                                  |
//+------------------------------------------------------------------+
int Reset() {
  if(LimitBars==0) LimitBars=Bars-1;  
  StartPos = MathMin(Bars-1,LimitBars);
  PreBars = 0;
  BarTime = 0;
  Shet    = 0;
  flag_G  = true; //    
  return(StartPos);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
//      
  if (Bars == PreBars) return(0);  
//      ,    
  if (Bars-PreBars == 1 && BarTime==Time[1]) StartPos = 1;
//       Reset()   
  else StartPos = Reset();
//   
  PreBars = Bars;  
  BarTime = Time[0];
//   
//Print("Bars=",Bars," StartPos=",StartPos); 
  for (pos=StartPos; pos>0; pos--) {
// ---------------    ----------------------------
    int t=iTime(Symbol(),PERIOD_H1,pos-1);//+2*60*60;
    int var=TimeHour(t);
    if(PreVar!=var) {   //     
      PreVar=var;
      SetColor(t);      //       
      SetVLine(LineColor, "VLine_"+Shet, t, STYLE_DOT,1,Period_Ris);
      Shet++;           //   
    }
//   . , ..    
   if(pos==1) {  
    ObjectDelete("VLine_"+Shet);
    SetColor(t+60*60);
    SetVLine(LineColor, "VLine_"+Shet, t+60*60, STYLE_DOT,1,Period_Ris);
   }
// --------------    ---------------------------
  if(flag_G && pos==1)  {           //  1   Reset()
   //     
   double   Max=iHigh(0,PERIOD_MN1,iHighest(NULL,PERIOD_MN1,MODE_HIGH,iBars(0,PERIOD_MN1),0));
   if(Max<=0) continue;             // , ..  
   double Uroven=0.0;               //    
   Period_Ris=0x1F;                 //    1,5,M15,M30  H1
   ObjectsDeleteAll(0,OBJ_HLINE);   //    
   i=0;
   while(Uroven<Max) {
     i++;
     if(MathMod(i,2)==0)   {
       LineColor=DimGray;        //  
       LineStile=STYLE_DASHDOTDOT;    
       }
     else {
       LineColor=DimGray;           //  
       LineStile=STYLE_DASHDOTDOT;    
     }  
     Uroven=i**Point; 
     SetHLine(LineColor, "HLine_"+i, Uroven, LineStile,0,Period_Ris);
   }// end while (Uroven<Max)
   if(Uroven>Max) flag_G=false;     //   
  }//end   

  }  //end  (pos=StartPos;pos>0;pos--) 
  return(0);
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//|  : . aka Prival                                        |
//+----------------------------------------------------------------------------+
//|     : 12.02.2009                                                     |
//|   :   OBJ_HLINE                 |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    cl -                                                           |
//|    nm -                ("" -    )     |
//|    p1 -              (0  - Bid)                              |
//|    st -                  (0  -  )                    |
//|    wd -                 (0  -  )                     |
//|    pr -           (0  -   ->   )       |
//+----------------------------------------------------------------------------+
void SetHLine(color cl, string nm="", double p1=0, int st=0, int wd=0, int pr=0) {
  if (nm=="") nm=DoubleToStr(Time[0], 0);
  if (p1<=0) p1=Bid;
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_HLINE, 0, 0,0); else Print("");
  ObjectSet(nm, OBJPROP_PRICE1, p1);
  ObjectSet(nm, OBJPROP_COLOR , cl);
  ObjectSet(nm, OBJPROP_STYLE , st);
  ObjectSet(nm, OBJPROP_WIDTH , wd);
  ObjectSet(nm, OBJPROP_TIMEFRAMES , pr);
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//|  : . aka Prival                                        |
//+----------------------------------------------------------------------------+
//|     : 12.02.2009                                                     |
//|   :   OBJ_VLINE                   |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    cl -                                                           |
//|    nm -                ("" -    )     |
//|    t1 -                       (0  -    )     |
//|    st -                  (0  -  )                    |
//|    wd -                 (1  -  )                     |
//|    pr -           (0  -   ->   )       |
//+----------------------------------------------------------------------------+
void SetVLine(color cl, string nm="", datetime t1=0, int st=0, int wd=1, int pr=0) {
  if (nm=="") nm=DoubleToStr(Time[0], 0);
  if (t1<=0) return; //t1=Time[0];
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_VLINE, 0, 0,0);
  ObjectSet(nm, OBJPROP_TIME1, t1);
  ObjectSet(nm, OBJPROP_COLOR, cl);
  ObjectSet(nm, OBJPROP_STYLE, st);
  ObjectSet(nm, OBJPROP_WIDTH, wd);
  ObjectSet(nm, OBJPROP_BACK , true);
  ObjectSet(nm, OBJPROP_TIMEFRAMES,pr);
}
//+----------------------------------------------------------------------------+
//|                                           |
//|                                                                |
//+----------------------------------------------------------------------------+
void  SetColor(int t)   {
  int var=TimeHour(t);
  LineColor=DimGray;    //    
  Period_Ris=0x3;       //   1  5           
  if(var==0) {
    LineColor=Blue;     //  
    Period_Ris=0x1F;    //   H1
  }
  if(var==London && var!=0) {
    LineColor=Gold;     //  
    Period_Ris=0x7;     //   1,5  15
  }
  if(var==0 && TimeDayOfWeek(t)==1) {
    LineColor=DeepPink; //  
    Period_Ris=0;       //  
  }
}